<?php
class file_upload
{

		public $the_file = NULL;
		public $the_temp_file = NULL;
		public $upload_dir = NULL;
		public $replace = NULL;
		public $do_filename_check = NULL;
		public $max_length_filename = 100;
		public $extensions = "all";
		public $ext_string = NULL;
		public $language = NULL;
		public $http_error = NULL;
		public $rename_file = NULL;
		public $file_copy = NULL;
		public $message = array( );
		public $create_directory = TRUE;

		public function file_upload( )
		{
				$this->language = "en";
				$this->rename_file = FALSE;
				$this->ext_string = "";
		}

		public function show_error_string( )
		{
				$msg_string = "";
				foreach ( $this->message as $value )
				{
						$msg_string .= $value;
				}
				return $msg_string;
		}

		public function set_file_name( $new_name = "" )
		{
				if ( $this->rename_file )
				{
						if ( $this->the_file == "" )
						{
								return;
						}
						$name = $new_name == "" ? strtotime( "now" ) : $new_name;
						sleep( 3 );
						$name .= $this->get_extension( $this->the_file );
						return $name;
				}
				else
				{
						$name = str_replace( " ", "_", $this->the_file );
				}
				return $name;
		}

		public function upload( $to_name = "" )
		{
				$new_name = $this->set_file_name( $to_name );
				if ( $this->check_file_name( $new_name ) )
				{
						if ( $this->validateExtension( ) )
						{
								if ( is_uploaded_file( $this->the_temp_file ) )
								{
										$this->file_copy = $new_name;
										if ( $this->move_upload( $this->the_temp_file, $this->file_copy ) )
										{
												$this->message[] = $this->error_text( $this->http_error );
												if ( $this->rename_file )
												{
														$this->message[] = sprintf( $this->error_text( 16 ), $this->file_copy );
												}
												return TRUE;
										}
										return FALSE;
								}
								$this->message[] = $this->error_text( $this->http_error );
								return FALSE;
						}
						$this->show_extensions( );
						$this->message[] = sprintf( $this->error_text( 11 ), $this->ext_string );
						return FALSE;
				}
				return FALSE;
		}

		public function check_file_name( $the_name )
		{
				if ( $the_name != "" )
				{
						if ( $this->max_length_filename < strlen( $the_name ) )
						{
								$this->message[] = sprintf( $this->error_text( 13 ), $this->max_length_filename );
								return FALSE;
						}
						if ( $this->do_filename_check == "y" )
						{
								if ( preg_match( "/^[a-z0-9_]*\\.(.){1,5}\$/i", $the_name ) )
								{
										return TRUE;
								}
								$this->message[] = $this->error_text( 12 );
								return FALSE;
						}
						return TRUE;
				}
				$this->message[] = $this->error_text( 10 );
				return FALSE;
		}

		public function get_extension( $from_file )
		{
				$ext = strtolower( strrchr( $from_file, "." ) );
				return $ext;
		}

		public function validateExtension( )
		{
				if ( $this->extensions == "all" )
				{
						return TRUE;
				}
				$extension = $this->get_extension( $this->the_file );
				$ext_array = $this->extensions;
				if ( in_array( $extension, $ext_array ) )
				{
						return TRUE;
				}
				return FALSE;
		}

		public function show_extensions( )
		{
				$this->ext_string = implode( " ", $this->extensions );
		}

		public function move_upload( $tmp_file, $new_file )
		{
				if ( $this->existing_file( $new_file ) )
				{
						$this->mohsen_file_name = strtolower( $new_file );
						$newfile = $this->upload_dir.$new_file;
						if ( $this->check_dir( $this->upload_dir ) )
						{
								if ( @move_uploaded_file( $tmp_file, @strtolower( $newfile ) ) )
								{
										@umask( 0 );
										@chmod( $newfile, 420 );
										return TRUE;
								}
								$this->message[] = $this->error_text( 14 );
								return FALSE;
						}
						$this->message[] = $this->error_text( 14 );
						return FALSE;
				}
				$this->message[] = sprintf( $this->error_text( 15 ), $this->the_file );
				return FALSE;
		}

		public function check_dir( $directory )
		{
				if ( !is_dir( $directory ) )
				{
						if ( $this->create_directory )
						{
								@umask( 0 );
								@mkdir( $directory, 511 );
								return TRUE;
						}
						return FALSE;
				}
				return TRUE;
		}

		public function existing_file( $file_name )
		{
				if ( $this->replace == "y" )
				{
						return TRUE;
				}
				if ( file_exists( $this->upload_dir.$file_name ) )
				{
						return FALSE;
				}
				return TRUE;
		}

		public function del_temp_file( $file )
		{
				$delete = @unlink( $file );
				clearstatcache( );
				if ( @file_exists( $file ) )
				{
						$filesys = eregi_replace( "/", "\\", $file );
						$delete = @system( "del ".$filesys );
						clearstatcache( );
						if ( @file_exists( $file ) )
						{
								$delete = @chmod( $file, 420 );
								$delete = @unlink( $file );
								$delete = @system( "del ".$filesys );
						}
				}
		}

		public function error_text( $err_num )
		{
				global $lang_error_upload;
				return $lang_error_upload[$err_num];
		}

		public function save_log( )
		{
		}

}

?>