if(typeof HTMLElement!="undefined" && ! HTMLElement.prototype.insertAdjacentElement) {
	HTMLElement.prototype.insertAdjacentElement = function (where,parsedNode) {
		switch (where) {
			case 'beforeBegin':
				this.parentNode.insertBefore(parsedNode,this)
				break;
			case 'afterBegin':
				this.insertBefore(parsedNode,this.firstChild);
				break;
			case 'beforeEnd':
				this.appendChild(parsedNode);
				break;
			case 'afterEnd':
				if (this.nextSibling)
					this.parentNode.insertBefore(parsedNode,this.nextSibling);
				else
					this.parentNode.appendChild(parsedNode);
				break;
		}
	}

	HTMLElement.prototype.insertAdjacentHTML = function (where,htmlStr) {
		var r = this.ownerDocument.createRange();
		r.setStartBefore(this);
		var parsedHTML = r.createContextualFragment(htmlStr);
		this.insertAdjacentElement(where,parsedHTML)
	}

	HTMLElement.prototype.insertAdjacentText = function (where,txtStr) {
		var parsedText = document.createTextNode(txtStr)
		this.insertAdjacentElement(where,parsedText)
	}
}

var FarsiType =
{
	farsiKey : [
		32    , 33    , 34    , 35    , 36    , 37    , 1548  , 1711  ,
		41    , 40    , 215   , 43    , 1608  , 45    , 46    , 47    ,
		48    , 49    , 50    , 51    , 52    , 53    , 54    , 55    ,
		56    , 57    , 58    , 1705  , 44    , 61    , 46    , 1567  ,
		64    , 1616  , 1584  , 125   , 1609  , 1615  , 1609  , 1604  ,
		1570  , 247   , 1600  , 1548  , 47    , 8217  , 1583  , 215   ,
		1563  , 1614  , 1569  , 1613  , 1601  , 8216  , 123   , 1611  ,
		1618  , 1573  , 126   , 1580  , 1688  , 1670  , 94    , 95    ,
		1662  , 1588  , 1584  , 1586  , 1740  , 1579  , 1576  , 1604  ,
		1575  , 1607  , 1578  , 1606  , 1605  , 1574  , 1583  , 1582  ,
		1581  , 1590  , 1602  , 1587  , 1601  , 1593  , 1585  , 1589  ,
		1591  , 1594  , 1592  , 60    , 124   , 62    , 1617
	],
	Type : true,
	counter : 0
}

FarsiType.enable_disable = function(Dis) {
	var invis, obj;

	if (!Dis.checked)  {
		FarsiType.Type = true;
		invis = 'visible';
	}
	else {
		FarsiType.Type = false;
		invis = 'hidden';
	}

	for (var i=1; i<= FarsiType.counter; i++) {
		obj = document.getElementById('FarsiType_button_' + i);
		obj.style.visibility = invis;
	}
}

FarsiType.init = function() {

	var Inputs = document.getElementsByTagName('INPUT');
	for (var i=0; i<Inputs.length; i++) {
		if (Inputs[i].type.toLowerCase() == 'text' && Inputs[i].lang.toLowerCase() == 'fa') {
			FarsiType.counter++;
			new FarsiType.KeyObject(Inputs[i], FarsiType.counter);
		}
	}

	var Areas = document.getElementsByTagName('TEXTAREA');
	for (var i=0; i<Areas.length; i++) {
		if (Areas[i].lang.toLowerCase() == 'fa') {
			FarsiType.counter++;
			new FarsiType.KeyObject(Areas[i], FarsiType.counter);
		}
	}

	var Dis = document.getElementById('disableFarsiType')
	if (Dis != null) {
		FarsiType.enable_disable (Dis);
		Dis.onclick = new Function( "FarsiType.enable_disable (this);" )
	}
}

FarsiType.KeyObject = function(z,x) {
	html_code="<input type='button' id=FarsiType_button_"+x+" style='border: none; background-image:none;background-color:gray; font-size:10; color:white; font-family:tahoma; padding: 1px; margin: 1px; width: auto; height: auto;' value='FA' />";
	mohsendavari= z.getAttribute('mohsendavari');
	if(  mohsendavari ){
		document.getElementById(mohsendavari).innerHTML = html_code;
	}else{
		z.insertAdjacentHTML("afterEnd",html_code );
	}
	z.bottelm = document.getElementById ('FarsiType_button_' + x);

	z.farsi = true;
	z.style.textAlign = "right";
	z.style.direction = "rtl";
	z.bottelm.title = 'Change lang to english';

	setSelectionRange = function(input, selectionStart, selectionEnd) {
		input.focus()
		input.setSelectionRange(selectionStart, selectionEnd)
	}

	isChangeLang = function(e) {
		if (e == null) e = window.event;
		var key = e.keyCode ? e.keyCode : e.charCode;
		if (key == 119) ChangeLang();
	}

	ChangeLang = function() {
		if (z.farsi) {
			z.farsi = false;
			z.bottelm.value = "EN";
			z.bottelm.title = 'Change lang to persian'
			if(  mohsendavari ){
				z.setAttribute("dir","ltr");
				z.style.direction = "ltr";
				z.style.textAlign = "left";
			}
		}
		else {
			z.farsi = true;
			z.bottelm.value = "FA";
			z.bottelm.title = 'Change lang to english'
			if(  mohsendavari ){
				z.setAttribute("dir","rtl");
				z.style.direction = "rtl";
				z.style.textAlign = "right";
			}
		}
		z.focus();
	}

	Convert = function(e) {

		if (FarsiType.Type) {

			if (e == null) e = window.event;
			eElement = (e.srcElement) ? e.srcElement : e.originalTarget;

			var key = e.keyCode ? e.keyCode : e.charCode;
			if (navigator.userAgent.toLowerCase().indexOf('opera')>-1) key = e.which;

			if ( (e.charCode != null) && (e.charCode != key) )	return;
			if (e.ctrlKey || e.altKey || e.metaKey || key == 13 || key == 27 || key == 8) return;
			if (key>128){
				alert("لطفا زبان ویندوز خود را بر روی انگلیسی قرار دهید\nPlease change your windows language to English");
				return false;
			}
			if (z.farsi && key > 31 && key < 128) {

				if ( (key >= 65 && key <= 90) && !e.shiftKey ) {
					alert("Caps Lock is On. To prevent entering farsi incorrectly, you should press Caps Lock to turn it off.");
					return false;
				}
				else if ( (key >= 97 && key <= 122 ) && e.shiftKey ) {
					alert("Caps Lock is On. To prevent entering farsi incorrectly, you should press Caps Lock to turn it off.");
					return false;
				}
				if (key == 32 && e.shiftKey)
					key = 8204;
				else
					key = FarsiType.farsiKey[key-32];
				try {
					e.keyCode = key
				}
				catch(error) {
					try {
						e.initKeyEvent("keypress", true, true, document.defaultView, false, false, true, false, 0, key, eElement);
					}
					catch(error) {
						try {
							var nScrollTop = eElement.scrollTop;
							var nScrollLeft = eElement.scrollLeft;
							var nScrollWidth = eElement.scrollWidth;

							replaceString = String.fromCharCode(key);

							var selectionStart = eElement.selectionStart;
							var selectionEnd = eElement.selectionEnd;
							eElement.value = eElement.value.substring(0, selectionStart) + replaceString + eElement.value.substring(selectionEnd);
							setSelectionRange(eElement, selectionStart + replaceString.length, selectionStart + replaceString.length);

							var nW = eElement.scrollWidth - nScrollWidth;
							if (eElement.scrollTop == 0) { eElement.scrollTop = nScrollTop }

							e.preventDefault()
						}
						catch(error) {
							alert('Sorry! no FarsiType support')
							FarsiType.Type = false;

							var Dis = document.getElementById('disableFarsiType')
							if (Dis != null) {
								Dis.disabled = true;
								Dis.checked = true;
							}

							for (var i=1; i<= FarsiType.counter; i++) {
								document.getElementById('FarsiType_button_' + i).style.visibility = 'hidden';
							}
							return false;
						}
					}
				}
			}
		}
		return true;
	}
	z.bottelm.onmouseup = ChangeLang;
	z.onkeydown = isChangeLang;
	z.onkeypress = Convert;
}

if (window.attachEvent) {
	window.attachEvent('onload', FarsiType.init)
}
else if (window.addEventListener) {
	window.addEventListener('load', FarsiType.init, false)
}
