var UploadProgress = {
	// Request URI (this bit needs work and might break with multiple progress meters if the request URIs are different)
	uri: null,

	// Request frequency
	frequency: 100,

	// To track null failures
	nullFails: 0,

	// Bar styling: http://www.barenakedapp.com/the-design/displaying-percentages
	bar: {
		image: 'images/percentImage.png',
		background: 'images/percentImage_back.png',
		style: ''
	},

	// Default callback - used to preload images
	onLoad: function() {
		var images = [ new Image(), new Image() ];
		images[0].src = UploadProgress.bar.image;
		images[1].src = UploadProgress.bar.background;
		UploadProgress.bar.style = 'padding: 0; background-position: -121px 0; '+
		'background: #eef6f6 url("'+UploadProgress.bar.background+'") top left no-repeat;';
	},

	// Default callback - creates a progress bar
	onCreate: function(identifier, form) {
		if (!$('upload_' + identifier)) {
			var img = document.createElement('img');
			img.setAttribute('id', 'upload_' + identifier);
			img.setAttribute('style', UploadProgress.bar.style);
			img.setAttribute('src', UploadProgress.bar.image);
			img.setAttribute('alt', '0%');
			img.setAttribute('title', '0%');
			/** var img = Builder.node('img', {
				id: 'upload_' + identifier, style: UploadProgress.bar.style, alt: '0%',
				src: UploadProgress.bar.image
			}); */
			$('upload_progress_place').appendChild(img);
$('form_upload_ajax').hide();
			
		}
		$('upload_' + identifier).style.backgroundPosition = '-121px';
	},

	// Default callback - updates a progress bar
	onUpdate: function(identifier, data) {
		
		var percent = Math.floor(data['bytes_uploaded'] * 100 / data['bytes_total']);
		$('upload_' + identifier).style.backgroundPosition = (percent - 110) + 'px 0';
		$('upload_' + identifier).alt = percent + '%';
		$('upload_' + identifier).title = percent + '%';

		if ($('uploadSpeed'))
			$('uploadSpeed').innerHTML = '&#1587;&#1585;&#1593;&#1578; &#1570;&#1662;&#1604;&#1608;&#1583; : '+Math.floor(data['speed_average'] / 1024)+'KB/s <br />  <br /> &#1583;&#1585;&#1589;&#1583; &#1570;&#1662;&#1604;&#1608;&#1583; : '+percent+'%';
	},

	// Default callback
	onComplete: function(identifier) {
		$('upload_' + identifier).style.backgroundPosition = '1px';
		$('upload_' + identifier).alt = '100%';
		$('upload_' + identifier).title = '100%';
		$('uploadSpeed').innerHTML ='فایل با موفقیت آپلود شد	[ <a href="index.php">ارسال فایل جدید</a> ]	';
		$('form_upload_ajax').remove();
	},

	// Enables the progress meter on a form
	__enable: function(form) {
		if (form.select('input[name="UPLOAD_IDENTIFIER"]')[0]) {
			var identifier = form.select('input[name="UPLOAD_IDENTIFIER"]')[0].value;
			if (UploadProgress.uri == null) UploadProgress.uri = form.getAttribute('action');
			UploadProgress.onCreate(identifier, form);
			setTimeout('UploadProgress.__tick("'+identifier+'")', UploadProgress.frequency);
		}
	},

	// Timer function
	__tick: function(identifier) {
		var uri = UploadProgress.uri;
		if ($('uploadForm_' + identifier)) uri = $('uploadForm_' + identifier).getAttribute('action');
		new Ajax.Request(UploadProgress.uri, { method: 'get', parameters: { UPLOAD_IDENTIFIER: identifier, kind: document.getElementById("kind").value , file_name :document.getElementById("uploadFile").value } });
	},

	// Called by the server
	__update: function(identifier, data) {
		setTimeout('UploadProgress.__tick("'+identifier+'");', UploadProgress.frequency);
		UploadProgress.onUpdate(identifier, data);
	},
	__davarirepeat:function(identifier) {
		UploadProgress.nullFails = UploadProgress.nullFails + 1;
		if (UploadProgress.nullFails < 5)
			setTimeout('UploadProgress.__tick("'+identifier+'");', UploadProgress.frequency);
		else {
			UploadProgress.onComplete(identifier);
			UploadProgress.nullFails = 0;
		}
	},
	
	__davarilink:function(identifier , data ) {
		UploadProgress.onComplete(identifier);
		var myinput = document.createElement('input');
		myinput.setAttribute('dir', 'ltr');
		myinput.setAttribute('type', 'text');
		myinput.setAttribute('value', data);
		myinput.setAttribute('size', 55);
		$('upload_link_place').appendChild(myinput);
	},
	__davarierror:function(identifier   , data  , new_identifier) {
		alert(data);
		$('form_upload_ajax').show();
		$('uploadIdentifier').setAttribute('value', new_identifier);
		$('upload_' + identifier).remove();
	}
};
Event.observe(window, 'load', function() {
	$$('form').each(function(form) {
		Event.observe(form, 'submit', function() { UploadProgress.__enable(this); });
		UploadProgress.onLoad();
	});
});
